Cache Algorithm Simulator
By Zhengyu Yang
last Update: Sept 2016

[1] Features:

[1.1] Input traces:
This simulator supports trace formats of MSR, UMass and FIU. Notice that it can only read files under the same format for each test. For example, it cannot run one MSR and one FIU trace together, but it can run multiple MSR traces together.

[1.2] Caching Algorithms: 
It simulates five different caching algorithms: LRU, CLOCK, ARC, CAR and CART. If multiple trace case, all these algorithms are in "global mode" which treats all trace as one single trace. For details, you can search terms like "Global LRU".

[1.3] Trace Number:
It supports both single trace and multiple traces.

[1.4] Output Results:
It mainly prints out the IO hit ratio, and cache-and-storage update times (which is for estiamtion of IO update cost). Besides them, it also prints out more detailed infos.

[1.5] Cache Line Size:
4KB.

[1.6] Cache Policy:
It supports both "write back" and "write through" cache policies.


[2] Compile:

To compile,  you can simpliy use the buit-in "Makefile" script. In detail, go to the file folder and run:
$ make clean
$ make
It may show some warnings, please ignore them. Finally, you will see the output file is named as "CacheSim", if it can successfully compile.


[3] Run:

[3.1] If you simplily run the "Cache" without any parameters, it then prints the usage guide, i.e.,
$ ./cache
$ Format: cache [cacheSize] [LRU 0/1] [CLOCK 0/1] [ARC 0/1] [CAR 0/1] [CART 0/1] [traceType 1=MSR/2=FIU/3=UMASS] [ResultFileName] [File1] [File2] ...

[3.2] If we have only one input file "mds_0.csv" from MSR trace, and we want to test ARC and CART algorithms under 4GB cache size, and print the results into "MDS0_ARC_CART_4GB", we can use:
$ ./ CacheSim 0 0 1 0 1 1 MDS0_ARC_CART_4GB mds_0.csv

[3.3] If we have multiple input files, e.g., "mds_0.csv" and "usr_2.csv" from MSR trace, and we want to test ARC and CART algorithms under 4GB cache size, and print the results into "MDS0_USR2_ARC_CART_4GB", we can use:
$ ./ CacheSim 0 0 1 0 1 1 MDS0_USR2_ARC_CART_4GB mds_0.csv

